module RocketFunctionObservableTest

using Test
using Rocket

include("../test_helpers.jl")

@testset "FunctionObservable" begin

    source1 = make(Int) do actor
        complete!(actor)
    end

    source2 = make(Float64) do actor
        setTimeout(100) do
            complete!(actor)
        end
    end

    source3 = make(Int) do actor
        next!(actor, 1)
        setTimeout(100) do
            complete!(actor)
        end
    end

    source4 = make(Int) do actor
        next!(actor, 1)
        setTimeout(100) do
            next!(actor, 2)
            complete!(actor)
        end
    end

    run_testset([
        (
            source = source1,
            values = @ts(c),
            source_type = Int
        ),
        (
            source = source2,
            values = @ts(100 ~ c),
            source_type = Float64
        ),
        (
            source = source3,
            values = @ts([ 1 ] ~ 100 ~ c),
            source_type = Int
        ),
        (
            source = source4,
            values = @ts([ 1 ] ~ 100 ~ [ 2, c ]),
            source_type = Int
        )
    ])

end

end
